//
// provides negative gradient vector -g and the matrix a using
// inputs from x, y, s, b, p, m and func().
// October 20, 2014
//

#include "fit.h"

void get_g_a(dvec& g, dmat& a, dvec x, dvec y, dvec s, dvec b, misc m)
{
  int i,j,k;
  int npar = m.npar;
  dbl f;
  dbl w;
  dvec p(npar);
  string fs;                                   // needed for call to func()

  for (j=0;j<npar;j++) {          // ensure g and a are initialized to zero
    g[j] = 0.0;
    for (k=0;k<npar;k++) {
      a[j][k] = 0.0;
    }
  }

  for (i=0;i<x.size();i++) {                            // now get -g and a
    f = func(x[i],b,p,fs,m);                            // need f = f(x[i])
    w = 1.0/(s[i]*s[i]);                             // weight of ith point
    for (j=0;j<npar;j++) {
      g[j] -= w*(f - y[i])*p[j];              // -= : we want -g components
      for (k=0;k<npar;k++) {
        a[j][k] += w*p[j]*p[k];                          // p[j] = df/db[j]
      }
    }
  }
}

