//
// Calculates and returns the value of phi from a call to func()
// with existing values of the parameters b[j]. The values of x,
// y and s are those already obtained from a previous call to
// get_data(). October 09, 2014.
//

#include "fit.h"

dbl get_phi(dvec x, dvec y, dvec s, dvec b, misc m)
{
  int i;
  dbl f;
  dbl w;
  dbl phi = 0.0;
  dvec p(m.npar);
  string fs;                                     // dummy, needed by func()

  for (i=0;i<x.size();i++) {
    f = func(x[i],b,p,fs,m);                            // need f = f(x[i])
    w = 1.0/(s[i]*s[i]);                             // weight of ith point
    phi += w*pow(f-y[i],2);
  }

  return phi;
}
